/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.tarifas;

import com.rjconsultores.ventaboletos.entidad.OrgaoConcedente;
import com.rjconsultores.ventaboletos.entidad.SeguroTarifa;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderTaxaEmbarqueOrgao;
import java.util.HashMap;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 * 
 * @author Administrador
 */
@Controller("busquedaSeguroTarifaController")
@Scope("prototype")
public class BusquedaSeguroTarifaController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
	private transient PagedListWrapper<OrgaoConcedente> plwOrgao;
	private MyListbox seguroTarifaList;
	private Paging pagingSeguroTarifa;
	private Textbox txtOrgao;

	public Paging getPagingSeguroTarifa() {
		return pagingSeguroTarifa;
	}

	public void setPagingSeguroTarifa(Paging pagingSeguroTarifa) {
		this.pagingSeguroTarifa = pagingSeguroTarifa;
	}

	public PagedListWrapper<OrgaoConcedente> getPlwOrgao() {
		return plwOrgao;
	}

	public void setPlwOrgao(PagedListWrapper<OrgaoConcedente> plwOrgao) {
		this.plwOrgao = plwOrgao;
	}

	public MyListbox getSeguroTarifaList() {
		return seguroTarifaList;
	}

	public void setSeguroTarifaList(MyListbox seguroTarifaList) {
		this.seguroTarifaList = seguroTarifaList;
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		seguroTarifaList.setItemRenderer(new RenderTaxaEmbarqueOrgao());
		seguroTarifaList.addEventListener("onDoubleClick", new EventListener() {

			@Override
			public void onEvent(Event event) throws Exception {
				OrgaoConcedente c = (OrgaoConcedente) seguroTarifaList.getSelected();
				verSeguroTarifa(c);
			}
		});

		refreshLista();

		txtOrgao.focus();
	}

	private void verSeguroTarifa(OrgaoConcedente o) {
		if (o == null) {
			return;
		}

		Map args = new HashMap();
		args.put("orgao", o);
		args.put("seguroTarifaList", seguroTarifaList);

		openWindow("/gui/tarifas/editarSeguroTarifa.zul",
				Labels.getLabel("busquedaSeguroTarifaController.window.title"),
				args, MODAL);
	}

	private void refreshLista() {

		HibernateSearchObject<OrgaoConcedente> seguroTarifaBusqueda =
				new HibernateSearchObject<OrgaoConcedente>(OrgaoConcedente.class,
						pagingSeguroTarifa.getPageSize());

		seguroTarifaBusqueda.addFilterEqual("activo", Boolean.TRUE);

		if (!txtOrgao.getValue().equals("")) {
			seguroTarifaBusqueda.addFilterLike("descOrgao",
					"%" + txtOrgao.getText().trim().concat("%"));
		}

		seguroTarifaBusqueda.addSortAsc("descOrgao");

		plwOrgao.init(seguroTarifaBusqueda, seguroTarifaList, pagingSeguroTarifa);

		if (seguroTarifaList.getData().length == 0) {
			try {
				Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
						Labels.getLabel("busquedaSeguroTarifaController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			} catch (InterruptedException ex) {
			}
		}
	}

	public void onClick$btnPesquisa(Event ev) {
		refreshLista();
	}

	public void onClick$btnRefresh(Event ev) {
		refreshLista();
	}

	public void onClick$btnNovo(Event ev) {
		verSeguroTarifa(new SeguroTarifa());
	}

	private void verSeguroTarifa(SeguroTarifa tx) {
		if (tx == null) {
			return;
		}

		Map args = new HashMap();
		args.put("orgao", null);
		args.put("seguroTarifa", tx);
		args.put("seguroTarifaList", seguroTarifaList);

		openWindow("/gui/tarifas/editarSeguroTarifa.zul",
				Labels.getLabel("busquedaSeguroTarifaController.window.title"),
				args, MODAL);
	}
}
